<?php

namespace Tests\Feature\V3\Azmayesh;

use App\Models\Azmayesh;
use App\Models\Permission;
use App\Models\User;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Illuminate\Foundation\Testing\WithFaker;
use Tests\TestCase;

class IndexTest extends TestCase
{
    use RefreshDatabase, WithFaker;
    /**
     * A basic feature test example.
     */
    public function test_user_should_have_azmayesh_management_permission(): void
    {
        $user = User::factory()->create();

        $response = $this->actingAs($user)->getJson(route('v3.azmayeshes.index', [
            'start' => 0,
            'size' => 10,
            'filters' => json_encode([]),
            'sorting' => json_encode([]),
        ]));

        $response->assertForbidden();
    }

    public function test_all_azmayeshes_returned_successfully(): void
    {
        $user = User::factory()
            ->has(Permission::factory([
                'name' => 'azmayesh-management'
            ]))
            ->create();

        Azmayesh::factory(5)->create();

        $response = $this->actingAs($user)->getJson(route('v3.azmayeshes.index', [
            'start' => 0,
            'size' => 10,
            'filters' => json_encode([]),
            'sorting' => json_encode([]),
        ]));

        $response->assertOk();

        $response->assertJsonStructure([
            'data' => [
                '*' => [
                    'id',
                    'lat',
                    'lng',
                    'request_date',
                    'report_date',
                    'request_number',
                    'employer',
                    'contractor',
                    'work_number',
                    'consultant',
                    'applicant',
                    'project_name',
                    'province_id',
                ],
            ],
            "meta" => [
                "totalRowCount"
            ]
        ]);
    }
}
